// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition" by Clifford A. Shaffer, Prentice Hall, 2007.
// Source code Copyright (C) 2006 by Clifford A. Shaffer.

// Test program for the sorted array-based list class

#include <iostream>
using namespace std;

#include "book.h"

// Include the comparator classes
#include "compare.h"

// Include the array-based list template code
#include "alist.ht"

// This is the specialization for sorted lists
#include "salist.h"

// Driver class for sorted array-based list implementation

int main(int argc, char** argv) {
  // Declare some sample lists
  SAList<Int*,intintCompare, getIntsKey> L1;
  SAList<Int*,intintCompare, getIntsKey> L2(15);
  SAList<Int,intintCompare, getIntKey> L3;

  Int dum;
  L3.insert(5);
  L3.insert(10);
  L3.insert(3);
  L3.insert(7);
  L3.print();
  L3.setStart();
  L3.remove(dum);
  cout << "Removed " << dum << endl;
  L3.print();
  return 0;
}
