template <class Elem>
class SkipNode {
public:
  int myLevel;
  Elem value;
  SkipNode** forward;
  SkipNode() {
    myLevel = MAXLEVEL;
    value = (Elem)NULL;
    forward = new SkipNode* [MAXLEVEL+1];
    for (int i=0; i<=MAXLEVEL; i++)
      forward[i] = NULL;
  }
  SkipNode(Elem r, int level) {
    myLevel = level;
    value = r;
    forward = new SkipNode* [level+1];
    for (int i=0; i<=level; i++)
      forward[i] = NULL;
  }
  ~SkipNode() { delete [] forward; }
};


template <class Key, class Elem, class Comp, class getKey>
class SkipList : public Dictionary<Key, Elem, Comp, getKey> {
private:
  SkipNode<Elem>* head;
  int level;
  int reccount;
  void AdjustHead(int& level) {level = MAXLEVEL;}
public:
  SkipList() {
    head = new SkipNode<Elem>;
    level = MAXLEVEL; reccount = 0;
  }
  void clear() { cout << "Clear not implemented\n"; }
  bool find(const Key& K, Elem& e) const;
  bool insert(const Elem& e);
  bool remove(const Key& K, Elem& e) { cout << "Remove not implemented\n"; }
  bool removeAny(Elem& e) { cout << "Removeany not implemented\n"; return false; }
  int size() { return reccount; }
  void print() const {
    for (SkipNode<Elem>* temp = head; temp!= NULL; temp = temp->forward[0]) {
      if (temp->value != NULL)
        cout << "temp->value is " << temp->value << "\n";
      for(int i=0; i<=temp->myLevel; i++)
        if (temp->forward[i] == NULL)
          cout << " point to NULL\n";
        else
          cout << " point to " << temp->forward[i]->value << "\n";
    }
  }
};
